    .586                      ; create 32 bit code
    .model flat, stdcall      ; 32 bit memory model
    option casemap :none      ; case sensitive

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    include \masm32\include\windows.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc

    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    WinMain         PROTO :DWORD,:DWORD,:DWORD,:DWORD
    WndProc         PROTO :DWORD,:DWORD,:DWORD,:DWORD
    CreateControls  PROTO :DWORD
    ReDrawButton    PROTO :DWORD
    TopXY           PROTO :DWORD,:DWORD

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    ;Button Styles (You Can Only Declare One Of These Values)
    
    btnRadio        equ 101
    btnAutoRadio    equ 102
    btnCheck        equ 103
    btnAutoCheck    equ 104 
    btn3State       equ 105
    btnAuto3State   equ 106

    ;Button Text formatting (btnVCenter and btnLeft Are Native Windows Styling)
    btnTop          equ 113
    btnVCenter      equ 112
    btnBottom       equ 111
    btnLeft         equ 114
    btnCenter       equ 115
    btnRight        equ 116
    btnMulti        equ 117

    ;Aux Style (btnLeftText And btnRightButton Are The Same Thing)
    btnFlat         equ 121
    btnPushLike     equ 122
    btnLeftText     equ 123
    btnRightButton  equ 124

    btnPushButton   equ 131
    
    

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

.data
    hInstance       dd 0
    hWnd            dd 0
    hDC             dd 0

    hButton1        dd 0
    hButton2        dd 0
    hButton3        dd 0
    hButton4        dd 0
    hButton5        dd 0
    hButton6        dd 0
    
    hButton7        dd 0
    hButton8        dd 0
    hButton9        dd 0
    hButton10       dd 0
    hButton11       dd 0
    hButton12       dd 0
    
    hButton13       dd 0
    hButton14       dd 0
    hButton15       dd 0
    hButton16       dd 0
    hButton17       dd 0
    hButton18       dd 0


    szButton1       db "Radio",0
    szButton2       db "Auto Radio",0
    szButton3       db "Check",0
    szButton4       db "Auto Check",0
    szButton5       db "3 State",0
    szButton6       db "Auto 3 State",0

    szButton7       db "Top",0
    szButton8       db "Verticle Center",0
    szButton9       db "Bottom",0
    szButton10      db "Left",0
    szButton11      db "Center",0
    szButton12      db "Right",0
    szButton13      db "Multi Line",0

    szButton14      db "Flat",0
    szButton15      db "Push Like",0
    szButton16      db "Left Text",0
    szButton17      db "Right Button",0

    szButton18      db "Redraw Examples",0

    szClassName     db "BUTTONEXAMPLE",0
    szDisplayName   db "Button Example",0
    szButtonClass   db "BUTTON",0

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

.code

start:
    invoke GetModuleHandle,0
    mov hInstance,eax
    invoke WinMain,hInstance,0,0,0
    invoke ExitProcess,eax

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

WinMain proc hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    ; ===============================
    ; Standard window creation stuff
    ; ===============================

    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    LOCAL Wwd:DWORD
    LOCAL Wht:DWORD
    LOCAL Wtx:DWORD
    LOCAL Wty:DWORD

    mov wc.cbSize,sizeof WNDCLASSEX
    mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
    mov wc.lpfnWndProc,OFFSET WndProc
    mov wc.cbClsExtra,0
    mov wc.cbWndExtra,0
    mov eax,hInst
    mov wc.hInstance,eax
    mov wc.hbrBackground,COLOR_WINDOW
    mov wc.lpszMenuName,0
    mov wc.lpszClassName,OFFSET szClassName
    mov wc.hIcon,0 
    invoke LoadCursor,0,IDC_ARROW
    mov wc.hCursor,eax
    mov wc.hIconSm,0

    invoke RegisterClassEx,ADDR wc

    mov Wwd,390 
    mov Wht,340
    invoke GetSystemMetrics,SM_CXSCREEN
    invoke TopXY,Wwd,eax
    mov Wtx,eax
    invoke GetSystemMetrics,SM_CYSCREEN
    invoke TopXY,Wht,eax
    mov Wty,eax

    invoke CreateWindowEx,WS_EX_LEFT,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPEDWINDOW,
                          Wtx,Wty,Wwd,Wht,
                          0,0,
                          hInstance,0

    mov hWnd,eax
    invoke ShowWindow,hWnd,SW_SHOW

    StartLoop:
      invoke GetMessage,ADDR msg,0,0,0
      cmp eax,0
      je ExitLoop
      invoke TranslateMessage,ADDR msg
      invoke DispatchMessage,ADDR msg
      jmp StartLoop
    ExitLoop:
      
    mov eax,msg.wParam 
    ret

WinMain endp

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

       .if uMsg == WM_CREATE

            invoke CreateControls,hWin

            ;This Is A Way I Found To Make Radio's Appear Indeterminate
            invoke SendMessage,hButton17,BM_SETSTATE,1,0

        .elseif uMsg == WM_COMMAND
                    ;There Are 2 API Calls To Get/Set The Checked Values
                    ;SendDlgItemMessage,(Window Handle),(Button ID),(BM),0,0
                    ;SendMessage,(Button Handle),(BM),0,0
            
                    ;There Are 2 Messages To Get The Checked Value 
                    ;BM_GETSTATE
                    ;BM_GETCHECK
            
                    ;There Is Only ONE Message To Set The Checked Value
                    ;BM_SETCHECK
                .if wParam == btnRadio; hButton1
                        invoke SendMessage,hButton1,BM_GETCHECK,0,0
                        .if eax==BST_UNCHECKED
                                invoke SendMessage,hButton1,BM_SETCHECK,BST_CHECKED,0
                                invoke SendMessage,hButton2,BM_SETCHECK,BST_UNCHECKED,0
                        .endif
                        
                .elseif wParam == btnAutoRadio; hButton2
                
                .elseif wParam == btnCheck; hButton3
                        invoke SendDlgItemMessage,hWnd,btnCheck,BM_GETCHECK,0,0
                        xor eax, 1
                        invoke SendDlgItemMessage,hWnd,btnCheck,BM_SETCHECK,eax,0
                        
                .elseif wParam == btnAutoCheck; hButton4
                
                .elseif wParam == btn3State; hButton5
                        ;To Set Indeterminate use BST_INDETERMINATE == 2
                        invoke SendMessage,hButton5,BM_GETSTATE,0,0
                        and eax, 1; Trap The Checked and Unchecked States Only
                        xor eax, 1
                        invoke SendMessage,hButton5,BM_SETCHECK,eax,0
                        
                .elseif wParam == btnAuto3State; hButton6
                
                .elseif wParam == btnTop; hButton7
                            
                .elseif wParam == btnVCenter; hButton8
                
                .elseif wParam == btnBottom; hButton9
                
                .elseif wParam == btnLeft; hButton10
                
                .elseif wParam == btnCenter; hButton11
                
                .elseif wParam == btnRight; hButton12
                
                .elseif wParam == btnMulti; hButton13
                
                .elseif wParam == btnFlat; hButton14
                
                .elseif wParam == btnPushLike; hButton15
                
                .elseif wParam == btnLeftText; hButton16
                
                .elseif wParam == btnRightButton; hButton17
                        invoke SendMessage,hButton17,BM_SETSTATE,1,0

                .elseif wParam == btnPushButton; hButton18
                        mov ebx, WS_CHILD or BS_RADIOBUTTON or WS_TABSTOP or WS_GROUP or WS_VISIBLE

                        invoke SendMessage,hButton7,BM_GETCHECK,0,0
                        .if eax == BST_CHECKED
                            or ebx, BS_TOP
                        .endif
                        invoke SendMessage,hButton8,BM_GETCHECK,0,0
                        .if eax == BST_CHECKED
                            or ebx, BS_VCENTER
                        .ENDIF
                        invoke SendMessage,hButton9,BM_GETCHECK,0,0
                        .if eax == BST_CHECKED
                            or ebx, BS_BOTTOM
                        .endif
                        invoke SendMessage,hButton10,BM_GETCHECK,0,0
                        .if eax == BST_CHECKED
                            or ebx, BS_LEFT
                        .endif
                        invoke SendMessage,hButton11,BM_GETCHECK,0,0
                        .if eax == BST_CHECKED
                            or ebx, BS_CENTER
                        .ENDIF
                        invoke SendMessage,hButton12,BM_GETCHECK,0,0
                        .if eax == BST_CHECKED
                            or ebx, BS_RIGHT
                        .endif
                        invoke SendMessage,hButton13,BM_GETCHECK,0,0
                        .if eax == BST_CHECKED
                            or ebx, BS_MULTILINE
                        .endif
                        invoke SendMessage,hButton14,BM_GETCHECK,0,0
                        .if eax == BST_CHECKED
                            or ebx, BS_FLAT
                        .endif
                        invoke SendMessage,hButton15,BM_GETCHECK,0,0
                        .if eax == BST_CHECKED
                            or ebx, BS_PUSHLIKE
                        .endif
                        invoke SendMessage,hButton16,BM_GETCHECK,0,0
                        .if eax == BST_CHECKED
                            or ebx, BS_LEFTTEXT
                        .endif
                        
                        invoke SendMessage,hButton1,BM_GETCHECK,0,0
                        push eax
                        invoke DestroyWindow,hButton1
                        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton1,ebx,
                                              10,10,180,40,
                                              hWin,btnRadio,
                                              hInstance,0
                        mov hButton1,eax   
                        pop eax
                        invoke SendMessage,hButton1,BM_SETCHECK,eax,0
                        
                        invoke SendMessage,hButton2,BM_GETCHECK,0,0
                        push eax
                        xor ebx, WS_GROUP
                        xor ebx, BS_RADIOBUTTON
                        xor ebx, BS_AUTORADIOBUTTON     
                        invoke DestroyWindow,hButton2
                        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton2,ebx,
                                              190,10,180,40,
                                              hWin,btnAutoRadio,
                                              hInstance,0
                        mov hButton2,eax   
                        pop eax
                        invoke SendMessage,hButton2,BM_SETCHECK,eax,0
                        
                        xor ebx, BS_AUTORADIOBUTTON
                        xor ebx, BS_CHECKBOX
                        
                        invoke SendMessage,hButton3,BM_GETCHECK,0,0
                        push eax
                        invoke DestroyWindow,hButton3
                        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton3,ebx,
                                              10,50,180,40,
                                              hWin,btnCheck,
                                              hInstance,0
                        mov hButton3,eax 
                        pop eax
                        invoke SendMessage,hButton3,BM_SETCHECK,eax,0
                        
                        invoke SendMessage,hButton4,BM_GETCHECK,0,0
                        push eax
                        xor ebx, BS_CHECKBOX
                        xor ebx, BS_AUTOCHECKBOX
                        invoke DestroyWindow,hButton4
                        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton4,ebx,
                                              190,50,180,40,
                                              hWin,btnAutoCheck,
                                              hInstance,0
                        mov hButton4,eax 
                        pop eax
                        invoke SendMessage,hButton4,BM_SETCHECK,eax,0
                        
                        invoke SendMessage,hButton5,BM_GETCHECK,0,0
                        push eax
                        xor ebx, BS_AUTOCHECKBOX
                        xor ebx, BS_3STATE
                        invoke DestroyWindow,hButton5
                        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton5,ebx,
                                              10,90,180,40,
                                              hWin,btn3State,
                                              hInstance,0
                        mov hButton5,eax 
                        pop eax
                        invoke SendMessage,hButton5,BM_SETCHECK,eax,0
                        
                        invoke SendMessage,hButton6,BM_GETCHECK,0,0
                        push eax
                        xor ebx, BS_3STATE
                        xor ebx, BS_AUTO3STATE
                        invoke DestroyWindow,hButton6
                        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton6,ebx,
                                              190,90,180,40,
                                              hWin,btnAuto3State,
                                              hInstance,0
                        mov hButton6,eax 
                        pop eax
                        invoke SendMessage,hButton6,BM_SETCHECK,eax,0
                .endif
        .elseif uMsg == WM_DESTROY
                invoke PostQuitMessage,0

        .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

CreateControls proc hWin:DWORD

        ;Define Our Demonstration Buttons
        ;The WS_GROUP Is What Defines The Group Of Radio Buttons.
        ;Each Group Is Defined By The First Control That Has This,
        ;And All Following Controls Until WS_GROUP Is Seen Again.
        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton1,
                              WS_CHILD or BS_RADIOBUTTON or WS_TABSTOP or WS_GROUP or WS_VISIBLE,
                              10,10,180,40,
                              hWin,btnRadio,
                              hInstance,0
        mov hButton1,eax        

        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton2,
                              WS_CHILD or BS_AUTORADIOBUTTON or WS_TABSTOP or WS_VISIBLE,
                              190,10,180,40,
                              hWin,btnAutoRadio,
                              hInstance,0
        mov hButton2,eax 

        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton3,
                              WS_CHILD or BS_CHECKBOX or WS_TABSTOP or WS_VISIBLE,
                              10,50,180,40,
                              hWin,btnCheck,
                              hInstance,0
        mov hButton3,eax 

        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton4,
                              WS_CHILD or BS_AUTOCHECKBOX or WS_TABSTOP or WS_VISIBLE,
                              190,50,180,40,
                              hWin,btnAutoCheck,
                              hInstance,0
        mov hButton4,eax 

        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton5,
                              WS_CHILD or BS_3STATE or WS_TABSTOP or WS_VISIBLE,
                              10,90,180,40,
                              hWin,btn3State,
                              hInstance,0
        mov hButton5,eax

        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton6,
                              WS_CHILD or BS_AUTO3STATE or WS_TABSTOP or WS_VISIBLE,
                              190,90,180,40,
                              hWin,btnAuto3State,
                              hInstance,0
        mov hButton6,eax 



        ;Define Our Text Formatting Buttons
        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton7,
                              WS_CHILD or BS_AUTORADIOBUTTON or WS_TABSTOP or WS_GROUP or WS_VISIBLE,
                              10,150,180,20,
                              hWin,btnLeft,
                              hInstance,0
        mov hButton7,eax

        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton8,
                              WS_CHILD or BS_AUTORADIOBUTTON or WS_TABSTOP or WS_VISIBLE,
                              10,170,180,20,
                              hWin,btnVCenter,
                              hInstance,0
        mov hButton8,eax
 
        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton9,
                              WS_CHILD or BS_AUTORADIOBUTTON or WS_TABSTOP or WS_VISIBLE,
                              10,190,180,20,
                              hWin,btnBottom,
                              hInstance,0
        mov hButton9,eax

        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton10,
                              WS_CHILD or BS_AUTORADIOBUTTON or WS_TABSTOP or WS_GROUP or WS_VISIBLE,
                              190,150,180,20,
                              hWin,btnLeft,
                              hInstance,0
        mov hButton10,eax
 
        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton11,
                              WS_CHILD or BS_AUTORADIOBUTTON or WS_TABSTOP or WS_VISIBLE,
                              190,170,180,20,
                              hWin,btnCenter,
                              hInstance,0
        mov hButton11,eax

        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton12,
                              WS_CHILD or BS_AUTORADIOBUTTON or WS_TABSTOP or WS_VISIBLE,
                              190,190,180,20,
                              hWin,btnRight,
                              hInstance,0
        mov hButton12,eax

        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton13,
                              WS_CHILD or BS_AUTOCHECKBOX or WS_TABSTOP or WS_VISIBLE,
                              95,210,180,20,
                              hWin,btnMulti,
                              hInstance,0
        mov hButton13,eax



        ;Define Aux Style Buttons
        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton14,
                              WS_CHILD or BS_AUTOCHECKBOX or WS_TABSTOP or WS_VISIBLE,
                              10,230,180,20,
                              hWin,btnFlat,
                              hInstance,0
        mov hButton14,eax

        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton15,
                              WS_CHILD or BS_AUTOCHECKBOX or WS_TABSTOP or WS_VISIBLE,
                              190,230,180,20,
                              hWin,btnPushLike,
                              hInstance,0
        mov hButton15,eax

        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton16,
                              WS_CHILD or BS_AUTOCHECKBOX or WS_TABSTOP or WS_VISIBLE,
                              10,250,180,20,
                              hWin,btnLeftText,
                              hInstance,0
        mov hButton16,eax



        ;Using A Regular Radio Button But Appear To Be Indeterminate
        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton17,
                              WS_CHILD or BS_RADIOBUTTON or WS_TABSTOP or WS_VISIBLE,
                              190,250,180,20,
                              hWin,btnRightButton,
                              hInstance,0
        mov hButton17,eax

        invoke CreateWindowEx,0,ADDR szButtonClass,ADDR szButton18,
                              WS_CHILD or BS_PUSHBUTTON or WS_TABSTOP or WS_VISIBLE,
                              95,270,180,20,
                              hWin,btnPushButton,
                              hInstance,0
        mov hButton18,eax
       

        ret

CreateControls endp

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

TopXY proc wDim:DWORD, sDim:DWORD
    shr sDim,1
    shr wDim,1
    mov eax,wDim
    sub sDim,eax
    mov eax,sDim

    ret

TopXY endp

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

end start
